# Definitions

## Compilation

The multi-stage process of translating the code of a higher-level language to the code of a lower-level language.



#### Compiler

a program that compiles code.



#### Conditional Compilation

a method which allows the compiler to produce differences in the executable based on the environment the code was compiled in.



## File Types

**source code (.c):**

Contain function definitions for headers.

**header (.h):**

Contains function declarations (aka. function prototypes) and preprocessor statements.

**object (.o) or (.obj):**

Produced as the output of the compiler and consists of function definitions in binary form.

**Binary (.exe) or (nothing):**

Produced as the output of the linker. The linker "links" one or more object files to produce a binary.

